﻿using Microsoft.AspNetCore.Mvc;
using ShipyardContracts.BindingModels;
using ShipyardContracts.ViewModels;
using ShipyardShopApp.Models;
using System.Diagnostics;

namespace ShipyardShopApp.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }
        [HttpGet]
        public IActionResult Enter() 
        {
            return View();
        }

        [HttpPost]
        public void Enter(string password)
        {
            if (string.IsNullOrEmpty(password)) 
            {
                throw new Exception("password");
            }
            APIClient.Access = password.Equals(APIClient.Password);
            if (APIClient.Access == false) 
            {
                throw new Exception("Не верный пароль");
            }
            Response.Redirect("Index");
        }


        public IActionResult Index()
        {
            if (APIClient.Access == false)
            {
                return Redirect("~/Home/Enter");
            }
            return View(APIClient.GetRequest<List<ShopViewModel>>($"api/shop/getshops"));
        }


        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }


        public IActionResult Create()
        {
            if (APIClient.Access == false)
            {
                return Redirect("~/Home/Enter");
            }
            return View();
        }

        [HttpPost]
        public void Create(string name, string address, DateTime date, int capacity) 
        {
            if (APIClient.Access == null)
            {
                throw new Exception("Вы как суда попали? Суда вход только авторизованным");
            }
            if (capacity <= 0)
            {
                throw new Exception("Вместимость должна быть больше 0");
            }
            if (string.IsNullOrEmpty(name)) 
            {
                throw new Exception("Введите имя");
            }
            if (string.IsNullOrEmpty(address))
            {
                throw new Exception("Введите адрес");
            }
            APIClient.PostRequest("api/shop/createshop", new ShopBindingModel
            {
                ShopName = name,
                Address = address,
                DateOpen = date,
                Capacity = capacity
            });
            Response.Redirect("Index");
        }
    }
}